using System.ComponentModel;

namespace TestProject
{
    /// <summary>
    /// ۾
    /// </summary>
    public class Task : INotifyPropertyChanged
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ӽ  - PropertyChanged

        /// <summary>
        /// Ӽ 
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ī
        /// </summary>
        private string name;

        /// <summary>
        /// 
        /// </summary>
        private string description;

        /// <summary>
        /// 켱 
        /// </summary>
        private int priority;

        /// <summary>
        /// ۾ Ÿ
        /// </summary>
        private TaskType type;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ī - Name

        /// <summary>
        /// Ī
        /// </summary>
        public string Name
        {
            get
            {
                return this.name;
            }
            set
            {
                this.name = value;

                FirePropertyChangedEvent("Name");
            }
        }

        #endregion
        #region  - Description

        /// <summary>
        /// 
        /// </summary>
        public string Description
        {
            get
            {
                return this.description;
            }
            set
            {
                this.description = value;

                FirePropertyChangedEvent("Description");
            }
        }

        #endregion
        #region 켱  - Priority

        /// <summary>
        /// 켱 
        /// </summary>
        public int Priority
        {
            get
            {
                return this.priority;
            }
            set
            {
                this.priority = value;

                FirePropertyChangedEvent("Priority");
            }
        }

        #endregion
        #region ۾ Ÿ - Type

        /// <summary>
        /// ۾ Ÿ
        /// </summary>
        public TaskType Type
        {
            get
            {
                return this.type;
            }
            set
            {
                this.type = value;

                FirePropertyChangedEvent("Type");
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Task()

        /// <summary>
        /// 
        /// </summary>
        public Task()
        {
        }

        #endregion
        #region  - Task(name, description, priority, type)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="name">Ī</param>
        /// <param name="description"></param>
        /// <param name="priority">켱 </param>
        /// <param name="type">۾ Ÿ</param>
        public Task(string name, string description, int priority, TaskType type)
        {
            this.name        = name;
            this.description = description;
            this.priority    = priority;
            this.type        = type;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString() => this.name;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Ӽ  ̺Ʈ ߻Ű - FirePropertyChangedEvent(propertyName)

        /// <summary>
        /// Ӽ  ̺Ʈ ߻Ű
        /// </summary>
        /// <param name="propertyName">Ӽ</param>
        protected void FirePropertyChangedEvent(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;

            handler?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}